﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AI;

public class OtherBearControls : MonoBehaviour {

	private bool isInfected;
	private bool isAlive;

	private Animator myAnim;

	// where am I trying to go?
	private NavMeshAgent agent;
	public Transform goal;

	private Vector3 myDestination;

	private Transform startTrans;
	private Vector3 startPos;
	private Quaternion startRot;

	void Awake() {
		startTrans = transform;
		startPos = startTrans.position;
		startRot = startTrans.rotation;
	}

	// Use this for initialization
	void Start () {
		// set the states
		isInfected = false;
		isAlive = true;

		// set the animator and start walking
		myAnim = GetComponent<Animator> ();
		myAnim.SetBool ("isWalking", true);
		myAnim.SetBool ("isDead", false);

		agent = GetComponent<NavMeshAgent>();
		myDestination = goal.position;
		agent.destination = myDestination;

	}
	
	// Update is called once per frame
	void Update () {
		
	}

	public IEnumerator Infected() {
		// set the material
		// GameObject myBearMesh = GetComponentInChildren<Renderer>();
		Renderer myMat = GetComponentInChildren<Renderer>();
		myMat.material.color = Color.magenta;


		// speed up
		agent.speed = 3.0f;
		agent.angularSpeed = 120.0f;

		// change directions
		PickNewDestination();
		// set seconds
		float seconds = 4.0f;

		for (int i = 0; i < 3; i++) {
			yield return new WaitForSeconds(seconds);
			StopWalking ();
			yield return new WaitForSeconds (1.5f);
			StartCoroutine (BearLogic.S.PooSplosion (this.transform));
			yield return new WaitForSeconds (1.0f);
			PickNewDestination ();
			StartWalking ();
			agent.speed += 1.0f;
			seconds++;
		}
			
		Die ();
	}

	void PickNewDestination() {
		Vector3 newDir = Random.onUnitSphere;
		// Debug.Log (newDir);
		myDestination = this.transform.position + (50 * newDir);
		// Debug.Log ("Agent Destination: " + agent.destination);
	}

	void StopWalking() {
		myAnim.SetBool ("isWalking", false);
		agent.destination = this.transform.position;
	}

	void StartWalking() {
		myAnim.SetBool ("isWalking", true);
		agent.destination = myDestination;
	}

	void Die() {
		StopWalking ();
		myAnim.SetBool ("isDead", true);
	}

	void Revive() {
		myAnim.SetBool ("isDead", false);
		this.tag = "Bear";

		Renderer myMat = GetComponentInChildren<Renderer>();
		myMat.material.color = Color.white;

		isInfected = false;
		isAlive = true;

	}

	void OnTriggerEnter(Collider col) {
		if (!isInfected) {
			if (col.transform.tag == "Poo") {
				isInfected = true;
				// this.tag = "Infected";
				Debug.Log ("OH NOES!!!");
				StartCoroutine (Infected ());
			}
		}
	}

	public void Reset() {
		// Debug.Log ("Resetting a bear");
		// reset the bear.
		transform.position = startPos;
		transform.rotation = startRot;

		// reset the target
		StopWalking();

		if (isInfected) {
			Revive ();
		}
	}


}
